# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Describes the progress of a partition's backup.
    #
    class BackupProgressInfo

      include MsRestAzure

      # @return [BackupState] Represents the current state of the partition
      # backup operation. Possible values include: 'Invalid', 'Accepted',
      # 'BackupInProgress', 'Success', 'Failure', 'Timeout'
      attr_accessor :backup_state

      # @return [DateTime] TimeStamp in UTC when operation succeeded or failed.
      attr_accessor :time_stamp_utc

      # @return Unique ID of the newly created backup.
      attr_accessor :backup_id

      # @return [String] Location, relative to the backup store, of the newly
      # created backup.
      attr_accessor :backup_location

      # @return [BackupEpoch] Specifies the epoch of the last record included
      # in backup.
      attr_accessor :epoch_of_last_backup_record

      # @return [String] The LSN of last record included in backup.
      attr_accessor :lsn_of_last_backup_record

      # @return [FabricErrorError] Denotes the failure encountered in
      # performing backup operation.
      attr_accessor :failure_error


      #
      # Mapper for BackupProgressInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'BackupProgressInfo',
          type: {
            name: 'Composite',
            class_name: 'BackupProgressInfo',
            model_properties: {
              backup_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'BackupState',
                type: {
                  name: 'String'
                }
              },
              time_stamp_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'TimeStampUtc',
                type: {
                  name: 'DateTime'
                }
              },
              backup_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'BackupId',
                type: {
                  name: 'String'
                }
              },
              backup_location: {
                client_side_validation: true,
                required: false,
                serialized_name: 'BackupLocation',
                type: {
                  name: 'String'
                }
              },
              epoch_of_last_backup_record: {
                client_side_validation: true,
                required: false,
                serialized_name: 'EpochOfLastBackupRecord',
                type: {
                  name: 'Composite',
                  class_name: 'BackupEpoch'
                }
              },
              lsn_of_last_backup_record: {
                client_side_validation: true,
                required: false,
                serialized_name: 'LsnOfLastBackupRecord',
                type: {
                  name: 'String'
                }
              },
              failure_error: {
                client_side_validation: true,
                required: false,
                serialized_name: 'FailureError',
                type: {
                  name: 'Composite',
                  class_name: 'FabricErrorError'
                }
              }
            }
          }
        }
      end
    end
  end
end
