# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_2_0_9
  module Models
    #
    # Information about an image store upload session. A session is associated
    # with a relative path in the image store.
    #
    class UploadSessionInfo

      include MsRestAzure

      # @return [String] The remote location within image store. This path is
      # relative to the image store root.
      attr_accessor :store_relative_path

      # @return A unique ID of the upload session. A session ID can be reused
      # only if the session was committed or removed.
      attr_accessor :session_id

      # @return [DateTime] The date and time when the upload session was last
      # modified.
      attr_accessor :modified_date

      # @return [String] The size in bytes of the uploading file.
      attr_accessor :file_size

      # @return [Array<UploadChunkRange>] List of chunk ranges that image store
      # has not received yet.
      attr_accessor :expected_ranges


      #
      # Mapper for UploadSessionInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'UploadSessionInfo',
          type: {
            name: 'Composite',
            class_name: 'UploadSessionInfo',
            model_properties: {
              store_relative_path: {
                client_side_validation: true,
                required: false,
                serialized_name: 'StoreRelativePath',
                type: {
                  name: 'String'
                }
              },
              session_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'SessionId',
                type: {
                  name: 'String'
                }
              },
              modified_date: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ModifiedDate',
                type: {
                  name: 'DateTime'
                }
              },
              file_size: {
                client_side_validation: true,
                required: false,
                serialized_name: 'FileSize',
                type: {
                  name: 'String'
                }
              },
              expected_ranges: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ExpectedRanges',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'UploadChunkRangeElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'UploadChunkRange'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
