# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Backup configuration information, for a specific partition, specifying
    # what backup policy is being applied and suspend description, if any.
    #
    class PartitionBackupConfigurationInfo < BackupConfigurationInfo

      include MsRestAzure


      def initialize
        @Kind = "Partition"
      end

      attr_accessor :Kind

      # @return [String] The full name of the service with 'fabric:' URI
      # scheme.
      attr_accessor :service_name

      # @return An internal ID used by Service Fabric to uniquely identify a
      # partition. This is a randomly generated GUID when the service was
      # created. The partition ID is unique and does not change for the
      # lifetime of the service. If the same service was deleted and recreated
      # the IDs of its partitions would be different.
      attr_accessor :partition_id


      #
      # Mapper for PartitionBackupConfigurationInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Partition',
          type: {
            name: 'Composite',
            class_name: 'PartitionBackupConfigurationInfo',
            model_properties: {
              policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PolicyName',
                type: {
                  name: 'String'
                }
              },
              policy_inherited_from: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PolicyInheritedFrom',
                type: {
                  name: 'String'
                }
              },
              suspension_info: {
                client_side_validation: true,
                required: false,
                serialized_name: 'SuspensionInfo',
                type: {
                  name: 'Composite',
                  class_name: 'BackupSuspensionInfo'
                }
              },
              Kind: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Kind',
                type: {
                  name: 'String'
                }
              },
              service_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'ServiceName',
                type: {
                  name: 'String'
                }
              },
              partition_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'PartitionId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
