# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_3_0_9
  module Models
    #
    # Describes the policy to be used for placement of a Service Fabric service
    # where the service's Primary replicas should optimally be placed in a
    # particular domain.
    #
    # This placement policy is usually used with fault domains in scenarios
    # where the Service Fabric cluster is geographically distributed in order
    # to indicate that a service's primary replica should be located in a
    # particular fault domain, which in geo-distributed scenarios usually
    # aligns with regional or datacenter boundaries. Note that since this is an
    # optimization it is possible that the Primary replica may not end up
    # located in this domain due to failures, capacity limits, or other
    # constraints.
    #
    class ServicePlacementPreferPrimaryDomainPolicyDescription < ServicePlacementPolicyDescription

      include MsRestAzure


      def initialize
        @Type = "PreferredPrimaryDomain"
      end

      attr_accessor :Type

      # @return [String] The name of the domain that should used for placement
      # as per this policy.
      attr_accessor :domain_name


      #
      # Mapper for ServicePlacementPreferPrimaryDomainPolicyDescription class
      # as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'PreferredPrimaryDomain',
          type: {
            name: 'Composite',
            class_name: 'ServicePlacementPreferPrimaryDomainPolicyDescription',
            model_properties: {
              Type: {
                client_side_validation: true,
                required: true,
                serialized_name: 'Type',
                type: {
                  name: 'String'
                }
              },
              domain_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'DomainName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
