# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V6_5_0_36
  module Models
    #
    # Describes the progress of a restore operation on a partition.
    #
    class RestoreProgressInfo

      include MsRestAzure

      # @return [RestoreState] Represents the current state of the partition
      # restore operation. Possible values include: 'Invalid', 'Accepted',
      # 'RestoreInProgress', 'Success', 'Failure', 'Timeout'
      attr_accessor :restore_state

      # @return [DateTime] Timestamp when operation succeeded or failed.
      attr_accessor :time_stamp_utc

      # @return [Epoch] Describes the epoch at which the partition is restored.
      attr_accessor :restored_epoch

      # @return [String] Restored LSN.
      attr_accessor :restored_lsn

      # @return [FabricErrorError] Denotes the failure encountered in
      # performing restore operation.
      attr_accessor :failure_error


      #
      # Mapper for RestoreProgressInfo class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'RestoreProgressInfo',
          type: {
            name: 'Composite',
            class_name: 'RestoreProgressInfo',
            model_properties: {
              restore_state: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoreState',
                type: {
                  name: 'String'
                }
              },
              time_stamp_utc: {
                client_side_validation: true,
                required: false,
                serialized_name: 'TimeStampUtc',
                type: {
                  name: 'DateTime'
                }
              },
              restored_epoch: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoredEpoch',
                type: {
                  name: 'Composite',
                  class_name: 'Epoch'
                }
              },
              restored_lsn: {
                client_side_validation: true,
                required: false,
                serialized_name: 'RestoredLsn',
                type: {
                  name: 'String'
                }
              },
              failure_error: {
                client_side_validation: true,
                required: false,
                serialized_name: 'FailureError',
                type: {
                  name: 'Composite',
                  class_name: 'FabricErrorError'
                }
              }
            }
          }
        }
      end
    end
  end
end
