# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::ServiceFabric::V7_0_0_42
  module Models
    #
    # Describes basic retention policy.
    #
    class BasicRetentionPolicyDescription < RetentionPolicyDescription

      include MsRestAzure


      def initialize
        @RetentionPolicyType = "Basic"
      end

      attr_accessor :RetentionPolicyType

      # @return [Duration] It is the minimum duration for which a backup
      # created, will remain stored in the storage and might get deleted after
      # that span of time. It should be specified in ISO8601 format.
      attr_accessor :retention_duration

      # @return [Integer] It is the minimum number of backups to be retained at
      # any point of time. If specified with a non zero value, backups will not
      # be deleted even if the backups have gone past retention duration and
      # have number of backups less than or equal to it.
      attr_accessor :minimum_number_of_backups


      #
      # Mapper for BasicRetentionPolicyDescription class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'Basic',
          type: {
            name: 'Composite',
            class_name: 'BasicRetentionPolicyDescription',
            model_properties: {
              RetentionPolicyType: {
                client_side_validation: true,
                required: true,
                serialized_name: 'RetentionPolicyType',
                type: {
                  name: 'String'
                }
              },
              retention_duration: {
                client_side_validation: true,
                required: true,
                serialized_name: 'RetentionDuration',
                type: {
                  name: 'TimeSpan'
                }
              },
              minimum_number_of_backups: {
                client_side_validation: true,
                required: false,
                serialized_name: 'MinimumNumberOfBackups',
                constraints: {
                  InclusiveMinimum: 0
                },
                type: {
                  name: 'Number'
                }
              }
            }
          }
        }
      end
    end
  end
end
